{% extends "scandb_base.html" %}

{% load i18n %}
{% load static %}

{% block scandb_extra_headers %}
<meta name="keywords" content="Openpaper, openpaper.work, scanner, database, db, Linux, Windows, WIA, TWAIN">
<meta name="description" content="{% trans "Scanner database (Windows / Linux)" %}">
{% endblock %}

{% block title %}
{% blocktrans %}
Scanner Database
{% endblocktrans %}
{% endblock %}

{% block scandb_body %}

{% if user.is_authenticated %}
<h2>Reports waiting for moderation</h2>

{% if unmoderated %}
<ul>
    {% for report in unmoderated %}
    <li><a href="{% url 'scannerdb:report' report.id %}">{{ report.creation_date }}</a></li>
    {% endfor %}
</ul>
{% else %}
<p>None</p>
{% endif %}

<table>
    <tr style="text-align: center;">
        <td>
            <form action="{% url 'scannerdb:analyze_all' %}" method="post">
                {% csrf_token %}
                <input type="submit" value="Analyze all" />
            </form>
        </td>
</table>

<h2>Introduction</h2>
{% endif %}

<img src="{% static "flatbed_and_feeder.png" %}" style="float: right; margin: 20px; margin-right: 0px;" width="256" height="auto" />

{% blocktrans %}
<p>
This database stores detailed information regarding scanners, their drivers and
<a href="https://gitlab.gnome.org/World/OpenPaperwork/libinsane">Libinsane</a>'s
support of those.
</p>
<p>
<a href="https://gitlab.gnome.org/World/OpenPaperwork/libinsane">Libinsane</a>
allows programs like
<a href="https://openpaper.work/">Paperwork</a> to use scanners on many platforms
(Linux, *BSD, Windows, etc). However, many scanners and scanners' drivers have
their own quirks. This database helps identify them. It also helps figuring out
which scanners are already correctly supported, and which ones need improvements.
</p>
<p>This database can also be of help when looking for a new scanner:
It can give you a good hint at what scanner manufacturers and models are best
supported by third-party applications on both GNU/Linux and Windows.</p>
{% endblocktrans %}

<table>
    <tr>
        <td style="padding-top: 0px;">
            <img src="{% static "ironscanner.png" %}" style="float: left; margin: 20px; margin-left: 0px;" width="160" height="auto" />
        </td>
        <td style="padding-top: 0px;">

{% blocktrans %}
<h2 id="contribute">Contributing</h2>
{% endblocktrans %}

{% blocktrans %}
<p>
A test program has been created to collect data quickly and automatically: <em>IronScanner</em>.
</p>

<p>You just have to run the program, select the scanner, define some basic test settings,
and run a test scan. It will then send the results to this database.</p>

<ul style="list-style-type: circle;">
    <li><a href="https://download.openpaper.work/windows/x86/ironscanner-master-latest.exe">Windows executable (64bits)</a></li>
    <li><a href="https://download.openpaper.work/linux/amd64/ironscanner-master-latest.appimage">Linux executable</a></li>
    <li><a href="https://gitlab.gnome.org/World/OpenPaperwork/ironscanner">Sources</a></li>
</ul>

<p>
<strong>Beware</strong> of the paper you will use for testing. The scanned paper will be
published here.<br/>
If you don't know what paper to use, you can simply print and then scan one of those test pages:
<a href="https://download.openpaper.work/test_pages/testpage-redhat-a4.pdf">A4</a> /
<a href="https://download.openpaper.work/test_pages/testpage-redhat-letter.pdf">Letter</a>
</p>

<p>
Test scan reports are published under the license <a href="https://en.wikipedia.org/wiki/WTFPL">WTFPL v2</a>.
By submitting a report here, you accept to publish it under this license.
</p>

{% endblocktrans %}
        </td>
    </tr>
</table>


{% blocktrans %}
{% endblocktrans %}

{% blocktrans %}
<h2>REST API</h2>
{% endblocktrans %}

{% blocktrans %}
<p>
This scanner database can also be accessed through a
<a href="/api/v1/scannerdb/">REST API</a> (read-only).
</p>
{% endblocktrans %}

{% blocktrans %}
<h2>Statistics - Success rates</h2>
{% endblocktrans %}

{% blocktrans %}
<h3>Global</h3>
{% endblocktrans %}

<table>
	<tr>
		{% for s in stats.global %}
		<th>{{ s.os.title }}</th>
		{% endfor %}
	</tr>
	<tr>
		{% for s in stats.global %}
		{% if s.percent is None %}
		<td></td>
		{% elif s.percent == 0 %}
		<td style="color: red;">{{ s.percent }}%</td>
		{% elif s.percent == 100 %}
		<td style="color: green;">{{ s.percent }}%</td>
		{% else %}
		<td>{{ s.percent }}%</td>
		{% endif %}
		{% endfor %}
	</tr>
</table>

{% blocktrans %}
<h3>Per manufacturer</h3>
{% endblocktrans %}

<table>
	<tr>
		<th>{% trans "Manufacturer" %}</th>
		{% for o in stats.oses %}
		<th>{{ o.title }}</th>
		{% endfor %}
	</tr>
	{% for s in stats.per_manufacturer %}
	<tr>
		<td>
			<a href="{% url 'scannerdb:vendor' s.manufacturer.id %}">
			{{ s.manufacturer.name.title }}
			</a>
		</td>
		{% for p in s.stats %}
		{% if p.percent is None %}
		<td></td>
		{% elif p.percent == 0 %}
		<td style="color: red;">{{ p.percent }}%</td>
		{% elif p.percent == 100 %}
		<td style="color: green;">{{ p.percent }}%</td>
		{% else %}
		<td>{{ p.percent }}%</td>
		{% endif %}
		{% endfor %}
	</tr>
	{% endfor %}
</table>

{% endblock %}
